import { world, system, EntityInventoryComponent } from "@minecraft/server";
import { hasArmor, hasInInventory } from "./lib/functions";

const armor = [
    "heavy:amethyst_helmet",
    "heavy:amethyst_chestplate",
    "heavy:amethyst_leggings",
    "heavy:amethyst_boots"
];

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const playerInventoryContainer = player.getComponent(EntityInventoryComponent.componentId).container;

        for (const armorSlot of armor) {
            hasInInventory(player, armorSlot, true).map(itemObject => {
                itemObject.item.setLore(["\n§r§c+1 Screech"]);
                playerInventoryContainer.setItem(itemObject.slot, itemObject.item);
            });
        }
    }
}, 20);

world.afterEvents.entityHurt.subscribe(async event => {
    const player = event.hurtEntity;

    if (!hasArmor(player, armor, "§r§c+1 Screech")) return;
    player.playSound("break.amethyst_block")
}, { entityTypes: [ "minecraft:player" ] });

system.beforeEvents.watchdogTerminate.subscribe(event => event.cancel = true);