import { EntityEquippableComponent, EquipmentSlot, EntityInventoryComponent } from "@minecraft/server";


export function hasArmor(player, armorIds, setLore = false) {
    const equipmentComponent = player.getComponent(EntityEquippableComponent.componentId);
    let result = false;

    for (const slot of Object.values(EquipmentSlot)) {
        const equipmentItem = equipmentComponent.getEquipment(slot);
        
        if (armorIds.includes(equipmentComponent.getEquipment(slot)?.typeId)) {
            if (setLore) {
                equipmentItem?.setLore([`\n${setLore}`]);
                equipmentComponent.setEquipment(slot, equipmentItem);
            }
            result = true;
        } 
    }
    return result
}

export function hasInInventory(player, itemId, getAll = false) {
    const inventoryContainer = player.getComponent(EntityInventoryComponent.componentId)?.container;
    const items = [];

    for (let i = 0; i < inventoryContainer.size; i++) {
        const item = inventoryContainer.getItem(i);

        if (!item || item?.typeId != itemId) continue;
        if (getAll) items.push({ slot: i, item });
        else return { slot: i, item };
    }
    return getAll ? items : null
}